include(defines.m4)dnl
changequote(`[!',`!]')dnl
@startuml
note "M4_LAST_GENERATED" as N1

Player o-- "1" Engine : engine
Player : Engine engine

Thread *-- "1" Engine : pEngine
Thread : Engine *pEngine

Engine : EEngine eState
Engine : CRITICAL_SECTION cs
Engine : IAudioClient *pAudioClient;
'Engine : IAudioClock *pAudioClock;
Engine : IAudioRenderClient *pAudioRenderClient;
Engine : EngineTimer timer
Engine : EngineThread thread
Engine : Ring ring
Engine o-- "1" EEngine : eState
enum EEngine {
  eEngineNull
  eEngineBase
  eEngineInitialized
  eEngineStarted
  eEngineDraining
  eEngineEot
}

Engine o-- "1" EngineTimer : timer
Engine o-- "1" EngineThread : thread
Engine o-- "1" Ring : ring

EEngine o-- EEngineBase : eEngineBase
enum EEngineBase {
  eEngineCriticalSection
ifdef([!M4_ON_TOP_VIS!],
[!  eEngineVis
!])dnl
  eEngineTimerEvent
  eEngineTimer
  eEngineEventProducer
  eEngineEventConsumer
ifdef([!M4_OPTION_GAPLESS!],[!  eEngineEventEot
!])dnl
ifdef([!M4_API!],[!  eEngineEventApi
!])dnl
  eEngineThread
  eEngineThreadRunning
}

ifdef([!M4_ON_TOP_VIS!],
[!EEngineBase o-- EEngineVis : eEngineVis
enum EEngineVis {
  eEngineVisExit
  eEngineVisTimer
  eEngineVisThread
}
!])dnl

EEngine o-- EEngineInitialized : eEngineInitialized
enum EEngineInitialized {
ifdef([!M4_OPTION_GAPLESS!],[!  eEngineClose
!])dnl
  eEngineAudioClientInititial
  eEngineRing
}

EEngine o-- EEngineStarted : eEngineStarted
enum EEngineStarted {
  eEnginePauseDisconnected
  eEngineAudioClient
  eEngineVolume
  eEngineAudioClock
  eEngineAudioRenderClient
  eEnginePauseConnected
  eEngineAudioClientStarted
  eEngineTimerStarted
}

EngineTimer : HANDLE hEvent
EngineTimer : HANDLE hTimer

ifdef([!M4_REQUEST_SIMPLIFIED!],
[!EngineThread o-- EEngine : eStateRequest
EngineThread : EEngine eStateRequest
!],
[!EngineThread : Request *pRequest
!])dnl
EngineThread : HANDLE hProducer
EngineThread : HANDLE hConsumer
ifdef([!M4_HANDLE_EOT!],ifdef([!M4_OPTION_GAPLESS!],[!EngineThread : HANDLE hEot
!]))
ifdef([!M4_API!],[!EngineThread : HANDLE hApi
!])
EngineThread : HANDLE hThread

ifdef([!M4_REQUEST_SIMPLIFIED!],,
[!EngineThread *-- "1" Request : pRequest
Request : ERequest eRequest
Request : EEngine eState
Request o-- "1" EEngine : eState
Request o-- "1" ERequest : eRequest
enum ERequest {
  eRequestNull
  eRequestExit
  eRequestStart
  eRequestFlush
  eRequestKill
}
!])dnl

Ring : UIN32 *_buf
Ring : UIN32 *_rp
Ring : UIN32 *_wp
Ring : UIN32 *_mp
Ring : Frames frames
Ring o-- "1" Frames : frames
Frames : WORD _uWritten
Frames : WORD _uAvailable
@enduml
