include(defines.m4)dnl
changequote(`[!',`!]')
@startuml
note "M4_LAST_GENERATED" as N1
eEngineBase : CRITICAL_SECTION Engine::cs
eEngineBase : HANDLE Engine::timer.hEvent
eEngineBase : HANDLE Engine::timer.hTimer
eEngineBase : HANDLE Engine::thread.hProducer
eEngineBase : HANDLE Engine::thread.hConsumer
ifdef([!M4_HANDLE_EOT!],
[!eEngineBase : HANDLE Engine::thread.hEot
!])dnl
ifdef([!M4_API!],
[!  eEngineBase : HANDLE Engine::thread.hApi
!])dnl
eEngineBase : HANDLE Engine::thread.hThread
eEngineBase --> eEngineInitialized : next track: acquire and initialize instances\nof <i>IAudioClient</i> and <i>YASAPI/NT</i>'s buffer
eEngineInitialized --> eEngineBase : stop/exit: release the instances of\n<i>YASAPI/NT</i>'s buffer and <i>IAudioClient</i>
eEngineInitialized : IAudioClient *Engine::pAudioClient
eEngineInitialized : Ring Engine::ring

eEngineInitialized --> eEngineInitialized : M4_EM([!Write!]) is called and the minimum amount of audio\nframes is not written yet to M4_EM([!YASAPI/NT!])'s buffer
eEngineInitialized --> eEngineStarted : M4_EM([!Write!]) is called and the minimum amount of audio\nframes is written to M4_EM([!YASAPI/NT!])'s buffer: acquire\nan instance of <i>IAudioRenderClient</i>

eEngineStarted : IAudioRenderClient *Engine::pAudioRenderClient
eEngineStarted --> eEngineInitialized : stop/exit: release the instance of <i>IAudioRenderClient</i>

'eEngineStarted --> eEngineDraining: drain
eEngineStarted --> eEngineDraining: M4_EM([!IsPlaying!]) is called for the first time
'eEngineStarted --> eEngineStarted : stop/exit
eEngineStarted --> eEngineStarted : <i>play</i> until M4_EM([!IsPlaying!]) is called for the first time
eEngineStarted --> eEnginePauseDisconnected : pause (with option disconnect):\nrelease the instances of\n<i>IAudioRenderClient</i> and <i>IAudioClient</i>
eEnginePauseDisconnected --> eEngineStarted : unpause: acquire fresh\ninstances of <i>IAudioClient</i> and\n<i>IAudioRenderClient</i> initialized with\nthe parameters already known

ifdef([!M4_OPTION_GAPLESS!],
[!eEngineDraining --> eEngineStarted : next track (gapless):\ncontinue with the instances of\n<i>IAudioClient</i> and <i>IAudioRenderClient</i>
!])dnl
eEngineDraining --> eEngineDraining : until <i>YASAPI/NT</i>'s\nbuffer is empty

eEngineDraining --> eEngineEot : <i>YASAPI/NT</i>'s buffer is empty
eEngineEot --> eEngineBase : ifdef([!M4_OPTION_GAPLESS!],[!next track (format changed):\nrelease !],[!next track: release !])the instances of\n<i>IAudioRenderClient</i> and <i>IAudioClient</i>
note bottom of eEngineEot : <u>e</u>nd <u>o</u>f <u>t</u>rack

eEngineBase --> [*] : exit: release the non-\n<i>WASAPI</i> objects

[*] --> eEngineBase : just when the first track is\nplayed: acquire non-<i>WASAPI</i>\nobjects from the <i>Windows</i> OS
[*] --> [*] : no track is ever\nplayed: nop
@enduml
