include(defines.m4)dnl
@startuml
note "M4_LAST_GENERATED" as N1
state eEngineStarted {
  [*] --> eEnginePauseDisconnected : creation (nop)
  eEnginePauseDisconnected --> [*] : destruction (nop)

  eEnginePauseDisconnected --> eEngineAudioClient : IMMDevice::Activate\n(when not already present)
  eEngineAudioClient --> eEnginePauseDisconnected : IUnknown::Release\n(always)
  eEngineAudioClient : IMMDevice *Engine::pDevice
  eEngineAudioClient : IAudioClient *Engine::pAudioClient

  eEngineAudioClient --> eEngineVolume : IEngineVolumeVtbl::Create
  eEngineVolume --> eEngineAudioClient : IEngineVolumeVtbl::Destroy
  eEngineVolume : IEngineVolumeVtbl *Engine::pIEngineVolumeVtbl
  eEngineVolume : void *Engine::pVolumeNull
  eEngineVolume : ISimpleAudioVolume *Engine::pSimpleAudioVolume
  eEngineVolume : IAudioEndpointVolume *Engine::pAudioEndpointVolume
  eEngineVolume : int Engine::pPlayer->param.nVolume

  eEngineVolume --> eEngineAudioClock : IEngineTimeVtbl::ClockCreate
  eEngineAudioClock --> eEngineVolume : IEngineTimeVtbl::ClockDestroy
  eEngineAudioClock : IEngineTimeVtbl *Engine::param.time.lpVtbl
  eEngineAudioClock : IAudioClock *Engine::pAudioClock
  eEngineAudioClock : double Engine::param.time.ms

  eEngineAudioClock --> eEngineAudioRenderClient : IAudioClient::GetService
  eEngineAudioRenderClient --> eEngineAudioClock : IUnknown:Release
  eEngineAudioRenderClient : IAudioClient *Engine::pAudioClient
  eEngineAudioRenderClient : IAudioRenderClient *Engine::pAudioRenderClient

  eEngineAudioRenderClient --> eEnginePauseConnected : nop
  eEnginePauseConnected --> eEngineAudioRenderClient : nop

  eEnginePauseConnected --> eEngineAudioClientStarted : IAudioClient::Start
  eEngineAudioClientStarted --> eEnginePauseConnected : IAudioClient::Stop
  eEngineAudioClientStarted : IAudioClient *Engine::pAudioClient

  eEngineAudioClientStarted --> eEngineTimerStarted : SetWaitableTimer (just\nwhen in <i>push</i> mode)
  eEngineTimerStarted --> eEngineAudioClientStarted : CancelWaitableTimer (just\nwhen in <i>push</i> mode)
  eEngineTimerStarted : HANDLE Engine::thread.hTimer

  [*] --> eEngineTimerStarted : destruction (nop)
  eEngineTimerStarted --> [*] : creation
}
@enduml
