/*
 * yasapi_config_label_uint32.c
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2015-2019  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>
#include <math.h>

static void LabelDoubleSet(ConfigWidget *pWidget)
{
  Dialog *pDialog=pWidget->pDialog;
  const char *format=pWidget->pCell->data;
  double *pxValue=(double *)pWidget->pCell->nav(pDialog,pWidget->pCell->offs);
  GtkWidget *widget = pWidget->widget;
  char buf[256];

  if (pxValue&&!YASAPI_DOUBLE_INVALID(*pxValue)) {
    sprintf_s (buf,sizeof buf,format?format:"%.0f",*pxValue);
    gtk_label_set_text (GTK_LABEL (widget), buf);
  }
  else
    gtk_label_set_text (GTK_LABEL (widget), "");
}

static void LabelDoubleGet(ConfigWidget *pWidget)
{
}

///////////////////////////////////////////////////////////////////////////////
static GtkWidget *ClassLabelDoubleCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  static IConfigWidgetVtbl vtbl={
    .set=LabelDoubleSet,
    .get=LabelDoubleGet,
  };

  GtkWidget *widget = gtk_label_new(NULL);

  ConfigWidgetCreate(pCell, pDialog, &vtbl, widget);

  return widget;
}

IClassCellVtbl gcIClassLabelDoubleVtbl={
  .create=ClassLabelDoubleCreate,
};
