/*
 * yasapi_producer_options.c
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2015-2019  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>

///////////////////////////////////////////////////////////////////////////////
#if ! defined (AUDCLNT_STREAMFLAGS_AUTOCONVERTPCM) // [
#define AUDCLNT_STREAMFLAGS_AUTOCONVERTPCM 0x80000000
#endif // ]

#if ! defined (AUDCLNT_STREAMFLAGS_SRC_DEFAULT_QUALITY) // [
#define AUDCLNT_STREAMFLAGS_SRC_DEFAULT_QUALITY 0x08000000
#endif // ]

int EngineOptionsCreate(EngineOptions *pOptions, EngineClient *pClient)
{
  int code=-1;
  OptionsCommon *pOptionsCommon=&pOptions->common;
  OptionsDevice *pOptionsDevice=&pOptions->device;
  Cache *pCache=&pClient->pPlayer->cache;

  /////////////////////////////////////////////////////////////////////////////
	memset(pOptions,0,sizeof *pOptions);

  /////////////////////////////////////////////////////////////////////////////
  *pOptionsCommon=pCache->options.common.current;
  *pOptionsDevice=pCache->selected.active.pCacheDevice->pMember->current;

	code=0;

  return code;
}
